import java.awt.Graphics;
import java.awt.Font;
import java.applet.Applet;
import java.awt.*;
import java.util.Random;
import java.applet.AudioClip;

import fire_shell;
import crown_shell;
import twin_shell;
import pistil_shell;
import saturn_shell;
import umbrella_shell;

import Sphere;
import Ring;

/***************************
  Launch a single Firework
***************************/

public class Fireworks extends java.applet.Applet implements Runnable {
    Thread killme = null;
    boolean threadSuspended = false;
    int w, h, cx, cy;
    int runlength;
    int color1, color2, color3;
    Sphere sphere3, sphere4, sphere5, sphere6, sphere8, sphere10;
    Ring ring8, ring10;
    fire_shell myshell;
    int shelltype;
	AudioClip	bomb;

    public void init() {
		try {
			shelltype=Integer.parseInt(getParameter("SHELLTYPE"));
		} catch (Exception e) {
			shelltype=1;
		}
		try {
			runlength=Integer.parseInt(getParameter("RUNLENGTH"));
		} catch (Exception e) {
			runlength=1;
		}
		try {
			color1=Integer.parseInt(getParameter("COLOR1"));
		} catch (Exception e) {
			color1=5;
		}
		try {
			color2=Integer.parseInt(getParameter("COLOR2"));
		} catch (Exception e) {
			color2=5;
		}
		try {
			color3=Integer.parseInt(getParameter("COLOR3"));
		} catch (Exception e) {
			color3=5;
		}
		try {
			w=Integer.parseInt(getParameter("WIDTH"));
		} catch (Exception e) {
			w=400;
		}
		try {
			h=Integer.parseInt(getParameter("HEIGHT"));
		} catch (Exception e) {
			h=300;
		}
		resize(w,h);
        cx=w/2;
        cy=h/2;
		sphere3=new Sphere(3);
		sphere4=new Sphere(4);
		sphere5=new Sphere(5);
		sphere6=new Sphere(6);
		sphere8=new Sphere(8);
		sphere10=new Sphere(10);
		ring8=new Ring(8);
		ring10=new Ring(10);
		bomb=getAudioClip(getCodeBase(), "sound/fwsound.au");

		switch(shelltype) {
		case 0:
			myshell=new crown_shell(cx,cy,100, 0, sphere6);
			break;
        case 1:
			myshell=new fire_shell(cx, cy ,100, 0, color1, sphere6);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
        case 2:
			myshell=new change_shell(cx, cy, 100, 0, color1, color2, sphere8);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
        case 3:
			myshell=new pistil_shell(cx, cy,100,0,color1, color2,sphere10,sphere5);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
        case 4:
			myshell=new pistil_shell(cx, cy ,100,0,color1, color2,color3 ,sphere10,sphere5);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
		case 5:
			myshell=new twin_shell(cx, cy, 100, 0, color1, color2, sphere6);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
        case 6:
			myshell=new saturn_shell(cx,cy,100, 0, color1, color2, sphere6, ring10);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
        case 7:
			myshell=new ring1_shell(cx,cy,100, 0, color1, color2, color3, ring10, ring8);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
        case 8:
			myshell=new ring2_shell(cx,cy,100, 0, color1, color2, color3, ring8);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
       case 9:
			myshell=new umbrella_shell(cx,cy,100, 0, color1, color2, 6);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
       case 10:
			myshell=new butterfly_shell(cx,cy,100, 0, color1, color2, 6);
			myshell.setRunLength(runlength);
			myshell.setGravity(0.003);
			break;
		}
		myshell.setAudio(bomb);
		this.setBackground(Color.black);
	}

    public void start() {
		if (killme == null) {
			killme = new Thread(this);
			killme.start();
		}
    }

    public void stop() {
		killme = null;
    }

    public void run() {
		while (killme != null) {
			try {
				Thread.sleep(50);
			} catch (InterruptedException e){}
			myshell.proceed();
			repaint();
		}
		killme = null;
    }

    public void repaint() {
		paint(getGraphics());
    }

    public void paint(Graphics g) {
		myshell.drawStars(g);
    }

} 

