//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <string.h>
#pragma hdrstop

//---------------------------------------------------------------------------

USEFORM("SSFrame.cpp", SSFrameO);
USERES("ScreenSaver.res");
USEUNIT("DDWrapper.cpp");
USEUNIT("Fclasses.cpp");
USEUNIT("fixed_math.cpp");
USEFORM("Prefs.cpp", PreferencesO);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE hPrevOInst,
				LPSTR pCmdLine, int cmdShow)
{
	// Check parameter string for configuration command /c
	strupr (pCmdLine);
	if (strstr (pCmdLine, "/C") != NULL)
	{
     	try
		{
   			Application->Initialize();
			Application->Title = "Pyro 32";
		Application->CreateForm(__classid(TPreferencesO), &PreferencesO);
		Application->Run();
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
	}
    else if ((strstr (pCmdLine, "/S") != NULL) ||
    		 (strlen(pCmdLine) <= 0))
    {
		// run the screen saver ....
		try
		{
			Application->Initialize();
			Application->CreateForm(__classid(TSSFrameO), &SSFrameO);
			Application->Run();
		}
		catch (Exception &exception)
		{
			Application->ShowException(&exception);
		}
    }

	return 0;
}

//---------------------------------------------------------------------------
